<template>
<div>
  <st-search
    md="12"
    text="Buscar por nombre o código"
    @enter="searchStudent($event)"
  />
  <st-select-table
    :dataInfo="{ headers,items,key }"
    :loading="loading"
    @selected="captureStudent($event)"
  />
  <div class="items-box">
      <div v-for="(student,index) in students" :key="student.codigo">
          <v-btn small text @click="deleteStudent(index)">X</v-btn>
          {{ student.nombres }}
    </div>
  </div>
  <div class="content-footer">
    <st-secondary-btn nombre="Cancelar" @click="$emit('cancel')"/>
    <st-primary-btn nombre="Registrar" @click="goNext()"  :loading="loadingPost"/>
  </div>
</div>
</template>

<script>
import Search from '@/components/Search'
import SelectTable from '@/components/SelectTable'

export default {
  data () {
    return{
      headers: [
        {
          text: 'Nombre',
          align: 'start',
          value: 'nombres',
        },
        {
          text: 'Código',
          value: 'codigo'
        },
      ],
      key: 'idAlumno',
      items:[],
      students:[],
      loading: false,
      loadingPost:false,
    }
  },
  components:{
    'st-search': Search,
    'st-select-table': SelectTable,
  },
  methods: {
    goNext(){
      this.loadingPost = true
      let data = this.students.map((student) => student.idAlumno)
      this.$emit('next',{ alumnos: data})
    },
    deleteStudent(index){
      this.students.splice(index,1)
    },
    captureStudent(value){
      let st = this.students.filter((obj) => obj.idAlumno == value.idAlumno)
      if (st.length == 0) this.students.push({idAlumno:value.idAlumno, nombres:value.nombres})
    },
    async searchStudent(value){
      this.loading = true
      try{
        let idUnit = this.$store.state.role.idUnit
        let { data: { data } } = await this.$api.getStudentsByUnit(idUnit, value)
        this.items = data
      } catch(e){
        this.$store.commit('setError', e)
      }
      this.loading = false
    },
  },
  computed:{
    valid(){
      return this.students.length !== 0
    }
  }
}
</script>

<style scoped lang="scss">
/* scope for encapsulate css */
</style>
